#ifndef _CONSTANTS_H
#define _CONSTANTS_H

#include <string>

namespace ib {
  
  enum BarSize {
    S_INVALID=0,
    S_1SEC=1,
    S_5SEC=2,
    S_15SEC=3,
    S_30SEC=4,
    S_1MIN=5,
    S_2MIN=6,
    S_5MIN=7,
    S_15MIN=8,
    S_30MIN=9,
    S_1HR=10,
    S_1DAY=11,
    S_1WK=12,
    S_1MON=13,
    S_3MON=14,
    S_1YR=15,
    S_3MIN=16,
    S_LAST
  };
  
  enum DataType {
    TRADES=0,
    MIDPOINT=1,
    BID=2,
    ASK=3,
    BID_ASK=4,
    HISTORICAL_VOLATILITY=5,
    OPTION_IMPLIED_VOLATILITY=6,
    OPTION_VOLUME=7,
    DT_INVALID=8
  };

  enum RTH {
    ALL=0,
    REGULAR_ONLY=1
  };
  
  enum DateFormat {
    STRING=1,
    TIME_T=2
  };

  void init();
  const std::string& datatype(enum DataType t);
  const std::string& barsize(enum BarSize s);
  const std::vector<std::string>* barsizes();
  const std::vector<std::string>* datatypes();

  BarSize string_to_barsize(char *spec);
  DataType string_to_datatype(char *spec);
} // namespace ib

#endif // _CONSTANTS_H
