#ifndef _CSVWRITER_H
#define _CSVWRITER_H

#include <map>
#include <vector>
#include <iostream>
#include <fstream>
#include <memory>

#include "Contract.h"

class csvWriter {
 public:
  typedef unsigned int handle;

 public:
  csvWriter() : nextHandle(1) { }
  ~csvWriter() { } 
  std::string genFilename(const Contract& c, time_t time);
  std::string genFilename(const Contract& c, const std::string ibtime);
  handle create(const std::string filename, bool truncate=true);
#if 0
  void addData(handle h, int i);
  void addData(handle h, double d);
  void addData(handle h, const std::string s);
  template <class T> 
    void addData(handle h, T d);
#endif
  void writeData(handle h);
  void addHeader(handle h, const std::string header);
  void writeHeader(handle h);
  void close(handle h);
  void addComment(handle h, const std::string comment);


  template <class T> 
    void addData(handle h, T d) {
    handleMapIterator it;
    
    it = hMap.find(h);
    if(it == hMap.end())
      return;
    
    std::ofstream& os = it->second->os;
    if(!it->second->firstitem)
      os << ",";
    os << d;
    it->second->firstitem = false;
  }
  
 private:
  struct fileState {
    handle h;
    std::ofstream os;
    std::vector<std::string> headers;
    bool firstitem;
  };

 private:  
  int nextHandle;
  typedef std::map<csvWriter::handle, struct fileState*> handleMap;
  typedef std::map<csvWriter::handle, struct fileState*>::iterator handleMapIterator;
  handleMap hMap;
};

#endif // _CSVWRITER_H
