#ifndef _util_h
#define _util_h

#include <string>
#include <iostream>
#include <stdexcept>

#include <time.h>

#include "Contract.h"
#include "Order.h"

// YYYYMMDD HH:DD:MM TZspec
#define IBTIME_FORMAT "%Y%m%d %H:%M:%S"
#define IBTIME_DATE_FORMAT "%Y%m%d"
#define TIMESTAMP_FORMAT "%Y%m%d %H:%M:%S"

std::ostream& operator<<(std::ostream& o, const Contract& c);
std::ostream& operator<<(std::ostream& o, const Order& o1);
std::ostream& operator<<(std::ostream& o, const ContractDetails& cd);
std::string timet_to_ibtime(time_t t, bool round_to_day=false);
time_t ibtime_to_timet(const std::string& ibtime) throw (std::runtime_error);
bool ibtime_valid(const std::string& time_string);
void gettimestamp(std::string& out);
void parse_connspec(const std::string& connspec, std::string& host, int& port) throw(std::runtime_error);
void resolve_futures_contract(const std::string& name, const std::string& date, std::string& out, int cutoff_mday=10);

#endif //_util_h
