#include <unistd.h>

#include "PosixTestClient.h"

const int MAX_ATTEMPTS = 3;
const int SLEEP_TIME = 5;

int main(int argc, char** argv) {
  const char* host = argc > 1 ? argv[1] : "";
  unsigned int port = 7496;
  int clientId = 0;  

  printf("Starting\n");

  for (int attempt=0; attempt<MAX_ATTEMPTS; attempt++) {
    printf("Attempt %d\n", attempt);
    PosixTestClient client;
    client.connect( host, port, clientId);

    while(client.isConnected()) 
      client.processMessages();

    printf("Sleeping %d seconds before next attempt\n", SLEEP_TIME);
    sleep(SLEEP_TIME);
  }

  printf ("End of POSIX Socket Client Test\n");
}

